package fr.jeremylebrun.ld41.entities;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Animation;
import com.badlogic.gdx.graphics.g2d.TextureRegion;

import fr.jeremylebrun.ld41.core.Shared;
import fr.jeremylebrun.ld41.menus.GameMenu;

public class SimpleAnimation extends Entity {

	protected float stateTime;
	protected Animation<TextureRegion> animation;
	protected int delay = 0;
	
	public SimpleAnimation(float x, float y, float width, float height, int level, Animation<TextureRegion> animation) {
		super(x, y,width, height, level);
		this.animation = animation;
		this.stateTime = 0f;
	}
	
	public SimpleAnimation(float x, float y,  float width, float height, int level, Animation<TextureRegion> animation, int delay) {
		super(x, y,width, height, level);
		this.animation = animation;
		this.stateTime = 0f;
		this.delay = delay;
	}

	@Override
	public void update(GameMenu game) {
		if(!destroy) {
			if(delay==0){
				stateTime += Gdx.graphics.getDeltaTime(); 
			}else{
				delay--;
			}
			if(delay==0 && animation.isAnimationFinished(stateTime)) {
				destroy = true;
			}
		}
		
	}

	@Override
	public void render(GameMenu game) {
		if(delay==0 && !destroy){
			Shared.GAME_BATCH.draw(animation.getKeyFrame(stateTime), x, y);
		}
	}
	
	public void renderDebug(GameMenu game) {
		
	}

}