package fr.jeremylebrun.ld41.menus;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;

import fr.jeremylebrun.ld41.core.Ressources;
import fr.jeremylebrun.ld41.core.Shared;

public class GameHud {

	private boolean gameover = false;
	private float gameoverOpacity = 0f;
	private int cptGameOver = 0;
	
	private boolean missionComplete = false;
	private float missionCompleteOpacity = 0f;
	private int cptMissionComplete = 0;

	private boolean letter_B = false;
	private boolean letter_i = false;
	private boolean letter_g = false;
	private boolean letter_b2  = false;
	private boolean letter_o = false;

	private float healOpacity = 0;
	private float letterOpacity = 0f;
	private char lastLetterTake = '_';
	
	private int nbDollars = 0;
	private int nbKills = 0;
	
	private int timer = 0;
	private int cptTimer = 0;


	public GameHud() {

	}

	public void init(GameMenu game) {

	}

	public void render(GameMenu game) {
		
		if(Shared.DEBUG) {
			Shared.FONT_SMALL.draw(Shared.MENU_BATCH, (int)game.getPlayer().getX()+" "+(int)game.getPlayer().getY()+ " | "+game.camera.far, 16, 16);

		}

		for(int i=0;i<game.getPlayer().getMaxLife();i++) {
			if(game.getPlayer().getLife()<=i) {
				Shared.MENU_BATCH.draw(Ressources.TX_HUD_LIFE_EMPTY, 4+(i*24), Shared.GAME_HEIGHT-24);
			}else {
				if(healOpacity>0f && game.getPlayer().getLife() == i) {
					Shared.MENU_BATCH.setColor(1f-healOpacity, 1f-healOpacity, 1f-healOpacity, 1f);
					healOpacity-=0.02f;
				}
				Shared.MENU_BATCH.draw(Ressources.TX_HUD_LIFE_FULL, 4+(i*24), Shared.GAME_HEIGHT-24);
			}
		}

		Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		renderLetters(game);

		if(gameover) {

			if(gameoverOpacity < 1f) {
				Shared.MENU_BATCH.setColor(1f, 1f, 1f, gameoverOpacity);
				gameoverOpacity+=0.05f;
			}

			Shared.MENU_BATCH.draw(Ressources.TX_GAMEOVER, 0,0);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}else if(missionComplete) {
			if(missionCompleteOpacity < 1f) {
				Shared.MENU_BATCH.setColor(1f, 1f, 1f, missionCompleteOpacity);
				missionCompleteOpacity+=0.05f;
			}
			Shared.MENU_BATCH.draw(Ressources.TX_EG_BACKGROUND, 0,0);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}
	}

	public void renderLetters(GameMenu game) {
		if(letter_B) {
			if(letterOpacity>0f && lastLetterTake == 'B') {
				Shared.MENU_BATCH.setColor(1f+letterOpacity, 1f+letterOpacity, 1f+letterOpacity, 1f);
			}
			Shared.MENU_BATCH.draw(Ressources.TX_ITEM_LETTER_B, 560, Shared.GAME_HEIGHT-28);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}
		if(letter_i) {
			if(letterOpacity>0f && lastLetterTake == 'i') {
				Shared.MENU_BATCH.setColor(1f+letterOpacity, 1f+letterOpacity, 1f+letterOpacity, 1f);
			}
			Shared.MENU_BATCH.draw(Ressources.TX_ITEM_LETTER_i, 571, Shared.GAME_HEIGHT-28);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}
		if(letter_g) {
			if(letterOpacity>0f && lastLetterTake == 'g') {
				Shared.MENU_BATCH.setColor(1f+letterOpacity, 1f+letterOpacity, 1f+letterOpacity, 1f);
			}
			Shared.MENU_BATCH.draw(Ressources.TX_ITEM_LETTER_g, 582, Shared.GAME_HEIGHT-28);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}
		if(letter_b2) {
			if(letterOpacity>0f && lastLetterTake == 'b') {
				Shared.MENU_BATCH.setColor(1f+letterOpacity, 1f+letterOpacity, 1f+letterOpacity, 1f);
			}
			Shared.MENU_BATCH.draw(Ressources.TX_ITEM_LETTER_b2, 595, Shared.GAME_HEIGHT-28);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}
		if(letter_o) {
			if(letterOpacity>0f && lastLetterTake == 'o') {
				Shared.MENU_BATCH.setColor(1f+letterOpacity, 1f+letterOpacity, 1f+letterOpacity, 1f);
			}
			Shared.MENU_BATCH.draw(Ressources.TX_ITEM_LETTER_o, 607, Shared.GAME_HEIGHT-28);
			Shared.MENU_BATCH.setColor(1f, 1f, 1f, 1f);
		}
	}

	public void update(GameMenu game) {
		if(gameover) {
			cptGameOver++;
			if(cptGameOver>200) {
				Ressources.MUSIC_01.stop();
				game.goToTitleMenu();

			}
		}else if(missionComplete) {
			cptMissionComplete++;
			if(cptMissionComplete>30) {
				Ressources.MUSIC_01.stop();
				game.goToMissionCompleteMenu();

			}
		}else {
			if(cptTimer<=0) {
				if(timer+1<Integer.MAX_VALUE) {
					timer++;
				}
				cptTimer = 60;
			}else {
				cptTimer--;
			}
		}
		

		if(Shared.DEBUG && Gdx.input.isKeyJustPressed(Keys.D)) {
			System.out.println((int)game.getPlayer().getX()+", "+(int)game.getPlayer().getY()+", "+game.getPlayer().getLevel());
		}
	}

	public void gameOver() {
		this.gameover = true;
		this.gameoverOpacity = 0f;
		this.cptGameOver = 0;
	}
	public void missionComplete() {
		this.missionComplete = true;
		this.missionCompleteOpacity = 0f;
		this.cptMissionComplete = 0;
	}

	public void heal() {
		healOpacity = 2f;
	}

	public void addLife() {
		healOpacity = 2f;
	}


	public boolean isGameOver() {
		return gameover;
	}
	public boolean isMissionComplete() {
		return missionComplete;
	}
	
	public void incDollars() {
		nbDollars++;
	}
	
	public void incKills() {
		nbKills++;
	}

	public int getNbDollars() {
		return nbDollars;
	}

	public int getNbKills() {
		return nbKills;
	}

	public void addLetter(char letter) {
		lastLetterTake = letter;
		letterOpacity = 2f;
		if(letter == 'B') {
			letter_B = true;
		}else if(letter == 'i') {
			letter_i = true;
		}else if(letter == 'g') {
			letter_g = true;
		}else if(letter == 'b') {
			letter_b2 = true;
		}else if(letter == 'o') {
			letter_o = true;
		}
	}

	public boolean isLetter_B() {
		return letter_B;
	}

	public boolean isLetter_i() {
		return letter_i;
	}

	public boolean isLetter_g() {
		return letter_g;
	}

	public boolean isLetter_b2() {
		return letter_b2;
	}

	public boolean isLetter_o() {
		return letter_o;
	}
	
	public int getTimer() {
		return timer;
	}
}
